import * as React from 'react';
import BicycleClient from 'bicycle/client';
import ErrorResult from 'bicycle/types/ErrorResult';
import { BaseRootQuery } from 'bicycle/typed-helpers/query';
import DeepPartial from '../helpers/DeepPartial';
export interface Status<QueryResult> {
    result: DeepPartial<QueryResult>;
    loaded: boolean;
    errors: ReadonlyArray<string>;
    errorDetails: ReadonlyArray<ErrorResult>;
    previousElement: React.ReactNode;
    loadingDuration: number;
}
export declare type RenderLoaded<QueryResult> = (result: QueryResult, client: BicycleClient, status: Status<QueryResult>) => React.ReactNode;
export declare type RenderMaybeLoaded<QueryResult> = (result: DeepPartial<QueryResult>, client: BicycleClient, status: Status<QueryResult>) => React.ReactNode;
export declare type RenderLoading<QueryResult> = (loadingDuration: number, client: BicycleClient, status: Status<QueryResult>) => React.ReactNode;
export declare type RenderErrors<QueryResult> = (errors: ReadonlyArray<string>, client: BicycleClient, status: Status<QueryResult>) => React.ReactNode;
export interface Props<QueryResult> {
    query: BaseRootQuery<QueryResult>;
    children: RenderLoaded<QueryResult>;
    renderLoading?: boolean | RenderLoading<QueryResult>;
    renderErrors?: boolean | RenderErrors<QueryResult>;
}
export default function Connect<QueryResult>(props: Props<QueryResult>): JSX.Element | null;
export declare function query<QueryResult>(query: BaseRootQuery<QueryResult>, children: RenderLoaded<QueryResult>): React.ReactElement<any>;
export declare function query<QueryResult>(query: BaseRootQuery<QueryResult>, children: RenderLoaded<QueryResult>, options: {
    renderLoading?: RenderLoading<QueryResult>;
    renderErrors?: RenderErrors<QueryResult>;
}): React.ReactElement<any>;
export declare function query<QueryResult>(query: BaseRootQuery<QueryResult>, children: RenderMaybeLoaded<QueryResult>, options: {
    renderLoading?: boolean | RenderLoading<QueryResult>;
    renderErrors?: boolean | RenderErrors<QueryResult>;
}): React.ReactElement<any>;
