"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var useClient_1 = require("./useClient");
/**
 * Check if there are any requests in flight. Ignores requests
 * sent before useHasRequestInFlight is called
 */
function useHasRequestInFlight() {
    var client = useClient_1.default();
    var _a = React.useState(false), hasRequestInFlight = _a[0], set = _a[1];
    React.useEffect(function () {
        var subscriptionA = client.subscribeToQueueRequest(function () {
            set(true);
        });
        var subscriptionB = client.subscribeToSuccessfulResponse(function (pendingMutations) {
            if (!pendingMutations) {
                set(false);
            }
        });
        return function () {
            subscriptionA.unsubscribe();
            subscriptionB.unsubscribe();
        };
    }, [client]);
    return hasRequestInFlight;
}
exports.default = useHasRequestInFlight;
//# sourceMappingURL=useHasRequestInFlight.js.map