"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var INTERVAL_DURAITON_MS = 100;
var isRunning = false;
var handlers = [];
var handlerInterval;
function onInterval() {
    var now = Date.now();
    handlers.forEach(function (handler) {
        handler.setDuration(now - handler.startTime);
    });
}
function useLoadingDuration(isLoading) {
    var _a = React.useState(0), duration = _a[0], setDuration = _a[1];
    React.useEffect(function () {
        if (isLoading) {
            if (duration !== 0) {
                setDuration(0);
            }
            var handler_1 = new Handler(setDuration, Date.now());
            handlers.push(handler_1);
            if (!isRunning) {
                handlerInterval = setInterval(onInterval, INTERVAL_DURAITON_MS);
            }
            return function () {
                handlers = handlers.filter(function (h) { return h !== handler_1; });
                if (handlers.length === 0 && handlerInterval) {
                    clearInterval(handlerInterval);
                    isRunning = false;
                }
            };
        }
        else if (duration !== 0) {
            setDuration(0);
        }
    }, [isLoading]);
    return duration;
}
exports.default = useLoadingDuration;
var Handler = /** @class */ (function () {
    function Handler(setDuration, startTime) {
        this.setDuration = setDuration;
        this.startTime = startTime;
    }
    return Handler;
}());
//# sourceMappingURL=useLoadingDuration.js.map