"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var useClient_1 = require("./useClient");
/**
 * Get the latest network error, unless it has been
 * dismissed or there has been a successful response
 * since.
 *
 * N.B. ignores errors thrown before you call useNetworkError
 */
function useNetworkError() {
    var client = useClient_1.default();
    var _a = React.useState(null), error = _a[0], setError = _a[1];
    React.useEffect(function () {
        var subscriptionA = client.subscribeToNetworkErrors(function (error) {
            setError(error);
        });
        var subscriptionB = client.subscribeToSuccessfulResponse(function () {
            setError(null);
        });
        return function () {
            subscriptionA.unsubscribe();
            subscriptionB.unsubscribe();
        };
    }, [client]);
    return [error, function () { return setError(null); }];
}
exports.default = useNetworkError;
//# sourceMappingURL=useNetworkError.js.map